package me.wazup.hideandseek;

import org.bukkit.block.BlockFace;
import java.lang.reflect.InvocationTargetException;
import me.wazup.hideandseek.utils.ReflectionUtils;
import org.bukkit.block.Block;
import org.bukkit.block.Sign;
import java.util.Collections;
import java.util.Comparator;
import me.wazup.hideandseek.managers.AchievementsManager;
import com.google.common.io.ByteArrayDataOutput;
import org.bukkit.inventory.meta.FireworkMeta;
import me.wazup.hideandseek.events.HASArenaStopEvent;
import com.google.common.io.ByteStreams;
import org.bukkit.Color;
import org.bukkit.FireworkEffect;
import org.bukkit.entity.Firework;
import me.wazup.hideandseek.managers.TitleManager;
import org.bukkit.util.Vector;
import me.wazup.hideandseek.events.HASArenaStartEvent;
import org.bukkit.potion.PotionEffectType;
import org.bukkit.plugin.Plugin;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.command.CommandSender;
import me.wazup.hideandseek.events.HASPlayerLeaveEvent;
import org.bukkit.event.Event;
import me.wazup.hideandseek.events.HASPlayerJoinEvent;
import java.util.Collection;
import me.wazup.hideandseek.utils.Utils;
import org.bukkit.entity.Player;
import me.wazup.hideandseek.xseries.XMaterial;
import org.bukkit.inventory.InventoryHolder;
import org.bukkit.Bukkit;
import java.util.Iterator;
import org.bukkit.ChatColor;
import me.wazup.hideandseek.utils.ItemStackBuilder;
import org.bukkit.Material;
import java.util.Date;
import java.util.HashMap;
import me.wazup.hideandseek.utils.FlexibleScoreboard;
import org.bukkit.potion.PotionEffect;
import java.util.List;
import org.bukkit.entity.Item;
import org.bukkit.scheduler.BukkitTask;
import org.bukkit.inventory.Inventory;
import org.bukkit.Location;
import org.bukkit.inventory.ItemStack;
import java.util.ArrayList;

public class Arena
{
    public static ArrayList<Arena> arenaObjects;
    public ArrayList<ItemStack> disguises;
    public ArrayList<String> players;
    public ArrayList<String> spectators;
    public ArrayList<Location> powerups;
    public String name;
    public int startingAmountOfSeekers;
    public int minHiders;
    public int maxPlayers;
    public Location lobbySpawn;
    public Location hidersSpawn;
    public Location seekersWaitingSpawn;
    public Location seekersPlayingSpawn;
    public Location sign;
    public Location behindSign;
    public ArenaState state;
    public Inventory editor;
    public boolean arenaBuilt;
    public BukkitTask lobbyTimer;
    public ItemStack arenaItem;
    public int arenaNumber;
    public ArrayList<String> seekers;
    ArrayList<String> startingSeekers;
    public ArrayList<String> hiders;
    public ArrayList<String> nonhidden;
    public ArrayList<String> hidden;
    ArrayList<Item> powerupsItems;
    public List<PotionEffect> seekerEffects;
    List<PotionEffect> hiderEffects;
    public int minPlayers;
    public int lobbyTime;
    public int gameTime;
    public int give_hider_items_after;
    public int hiders_become_solid_after;
    public int warn_about_time_every;
    public int powerups_spawn_every;
    public FlexibleScoreboard scoreboard;
    public Inventory disguisesInventoryEditor;
    public Inventory disguisesInventory;
    BukkitTask gameTimer;
    long currentGamePlayTime;
    public boolean canUsefireWorks;
    String date;
    public ItemStack voteItem;
    HashMap<String, Location> playersLocation;
    public HashMap<String, Integer> stillCounter;
    public HashMap<String, ItemStack> playerDisguise;
    private final HideAndSeek plugin;
    
    public Arena(final HideAndSeek plugin, final String str, final int startingAmountOfSeekers, final int minHiders, final int n, final Location lobbySpawn, final Location hidersSpawn, final Location seekersWaitingSpawn, final Location seekersPlayingSpawn, final ArenaState state, final ArrayList<ItemStack> disguises, final int lobbyTime, final int gameTime, final Location sign, final ArrayList<Location> powerups, final int give_hider_items_after, final int hiders_become_solid_after, final int warn_about_time_every, final int powerups_spawn_every, final List<PotionEffect> seekerEffects, final List<PotionEffect> hiderEffects) {
        this.players = new ArrayList<String>();
        this.spectators = new ArrayList<String>();
        this.seekers = new ArrayList<String>();
        this.startingSeekers = new ArrayList<String>();
        this.hiders = new ArrayList<String>();
        this.nonhidden = new ArrayList<String>();
        this.hidden = new ArrayList<String>();
        this.powerupsItems = new ArrayList<Item>();
        this.playersLocation = new HashMap<String, Location>();
        this.stillCounter = new HashMap<String, Integer>();
        this.playerDisguise = new HashMap<String, ItemStack>();
        this.plugin = plugin;
        this.name = str;
        this.startingAmountOfSeekers = startingAmountOfSeekers;
        this.minHiders = minHiders;
        this.minPlayers = startingAmountOfSeekers + minHiders;
        this.maxPlayers = n;
        this.lobbyTime = lobbyTime;
        this.gameTime = gameTime;
        this.lobbySpawn = lobbySpawn;
        this.hidersSpawn = hidersSpawn;
        this.seekersWaitingSpawn = seekersWaitingSpawn;
        this.seekersPlayingSpawn = seekersPlayingSpawn;
        this.state = state;
        this.disguises = disguises;
        this.sign = sign;
        this.powerups = powerups;
        this.give_hider_items_after = give_hider_items_after;
        this.hiders_become_solid_after = hiders_become_solid_after;
        this.warn_about_time_every = warn_about_time_every;
        this.powerups_spawn_every = powerups_spawn_every;
        this.seekerEffects = seekerEffects;
        this.hiderEffects = hiderEffects;
        this.date = plugin.dateFormat.format(new Date());
        if (Config.getInstance().JoinGuiEnabled) {
            this.arenaItem = new ItemStackBuilder(Material.CHEST).setName(ChatColor.AQUA + str).addLore(new String[] { state.text + " - " + plugin.customization.sign_join_line4_format.replace("%players%", String.valueOf(this.players.size())).replace("%maxplayers%", String.valueOf(n)) }).build();
            this.arenaNumber = Arena.arenaObjects.size();
        }
        this.loadEditor();
        this.updateArenaBuilt();
        this.updateBehindSign();
        this.updateSignPlayers();
        this.updateSignState();
        this.setupScoreboard();
        final ItemStackBuilder setName = new ItemStackBuilder(Material.NAME_TAG).setName(ChatColor.AQUA + str);
        final Iterator<String> iterator = plugin.customization.arenaVoteItemLore.iterator();
        while (iterator.hasNext()) {
            setName.addLore(new String[] { iterator.next() });
        }
        this.voteItem = setName.build();
        Arena.arenaObjects.add(this);
    }
    
    public static Arena valueOf(final String anotherString) {
        for (final Arena arena : Arena.arenaObjects) {
            if (arena.name.equalsIgnoreCase(anotherString)) {
                return arena;
            }
        }
        return null;
    }
    
    public static String getDurationString(int n) {
        final int n2 = n % 3600 / 60;
        n %= 60;
        return twoDigitString(n2) + ":" + twoDigitString(n);
    }
    
    public static String twoDigitString(final int n) {
        if (n == 0) {
            return "00";
        }
        if (n / 10 == 0) {
            return "0" + n;
        }
        return String.valueOf(n);
    }
    
    public void updateArenaBuilt() {
        this.arenaBuilt = (this.lobbySpawn != null && this.hidersSpawn != null && this.seekersWaitingSpawn != null && this.seekersPlayingSpawn != null && this.startingAmountOfSeekers > 0 && this.minHiders > 0);
    }
    
    public void loadEditor() {
        this.editor = Bukkit.createInventory((InventoryHolder)null, 54, ChatColor.DARK_PURPLE + "Editing: " + this.name);
        final ItemStack build = new ItemStackBuilder(XMaterial.LIME_STAINED_GLASS_PANE.parseItem()).setName(ChatColor.GREEN + "+").build();
        final ItemStack build2 = new ItemStackBuilder(XMaterial.RED_STAINED_GLASS_PANE.parseItem()).setName(ChatColor.RED + "-").build();
        for (int i = 0; i < 54; ++i) {
            this.editor.setItem(i, this.plugin.locked);
        }
        for (int j = 0; j < 9; ++j) {
            this.editor.setItem(j, build);
        }
        for (int k = 18; k < 27; ++k) {
            this.editor.setItem(k, build2);
        }
        final ItemStackBuilder itemStackBuilder = new ItemStackBuilder(Material.PAPER);
        this.editor.setItem(9, itemStackBuilder.setName(ChatColor.YELLOW + "Starting amount of seekers: " + ChatColor.GOLD + this.startingAmountOfSeekers).build());
        this.editor.setItem(10, itemStackBuilder.setName(ChatColor.YELLOW + "Min hiders: " + ChatColor.GOLD + this.minHiders).build());
        this.editor.setItem(11, itemStackBuilder.setName(ChatColor.YELLOW + "Max players: " + ChatColor.GOLD + this.maxPlayers).build());
        this.editor.setItem(12, itemStackBuilder.setName(ChatColor.YELLOW + "Lobby wait time: " + ChatColor.GOLD + this.lobbyTime).build());
        this.editor.setItem(13, itemStackBuilder.setName(ChatColor.YELLOW + "Game length: " + ChatColor.GOLD + this.gameTime).build());
        this.editor.setItem(14, itemStackBuilder.setName(ChatColor.YELLOW + "Give hiders their items after: " + ChatColor.GOLD + this.give_hider_items_after).build());
        this.editor.setItem(15, itemStackBuilder.setName(ChatColor.YELLOW + "Hiders become solid after: " + ChatColor.GOLD + this.hiders_become_solid_after).build());
        this.editor.setItem(16, itemStackBuilder.setName(ChatColor.YELLOW + "Warn about time every: " + ChatColor.GOLD + this.warn_about_time_every).build());
        this.editor.setItem(17, itemStackBuilder.setName(ChatColor.YELLOW + "Powerups spawn every: " + ChatColor.GOLD + this.powerups_spawn_every).build());
        this.editor.setItem(37, new ItemStackBuilder(Material.CHEST).setName(ChatColor.LIGHT_PURPLE + "Arena blocks").build());
        final ItemStack build3 = new ItemStackBuilder(XMaterial.LIME_DYE.parseItem()).setName(ChatColor.GREEN + "Enabled").build();
        final ItemStack build4 = new ItemStackBuilder(XMaterial.GRAY_DYE.parseItem()).setName(ChatColor.RED + "Disabled").build();
        this.editor.setItem(40, (this.state == ArenaState.DISABLED) ? build4 : build3);
        this.editor.setItem(43, new ItemStackBuilder(Material.DIAMOND).setName(ChatColor.AQUA + "Save & Apply").build());
        (this.disguisesInventoryEditor = Bukkit.createInventory((InventoryHolder)null, 54, ChatColor.DARK_RED + "Arena blocks: " + this.name)).setItem(53, new ItemStackBuilder(Material.CHEST).setName(ChatColor.RED + "Back").build());
        final Iterator<ItemStack> iterator = this.disguises.iterator();
        while (iterator.hasNext()) {
            this.disguisesInventoryEditor.addItem(new ItemStack[] { iterator.next() });
        }
        final int size = this.disguises.size();
        this.disguisesInventory = Bukkit.createInventory((InventoryHolder)null, (size < 10) ? 9 : ((size < 19) ? 18 : ((size < 28) ? 27 : ((size < 37) ? 36 : ((size < 46) ? 45 : 54)))), (String)this.plugin.customization.inventories.get("Disguise-Selector"));
        final Iterator<ItemStack> iterator2 = this.disguises.iterator();
        while (iterator2.hasNext()) {
            this.disguisesInventory.addItem(new ItemStack[] { iterator2.next() });
        }
    }
    
    public void setupScoreboard() {
        if (!Config.getInstance().arenaScoreboardEnabled) {
            return;
        }
        (this.scoreboard = new FlexibleScoreboard(this.plugin.customization.arenaScoreboardTitle, false, this.plugin.customization.scoreboard)).update("%arena_hiders%", 0);
        this.scoreboard.update("%arena_seekers%", 0);
        this.scoreboard.update("%arena_name%", this.name);
        this.scoreboard.update("%date%", this.date);
        this.scoreboard.update("%state%", this.state.text);
        this.scoreboard.update("%timer%", "0:00");
    }
    
    public ArrayList<Player> getPlayers(final boolean b) {
        if (!b) {
            return Utils.getPlayers((Collection)this.players);
        }
        final ArrayList list = new ArrayList((Collection<? extends E>)this.players);
        list.addAll(this.spectators);
        return Utils.getPlayers((Collection)list);
    }
    
    public ArrayList<Player> getSpectators() {
        return Utils.getPlayers((Collection)this.spectators);
    }
    
    public ArrayList<Player> getHiders() {
        return Utils.getPlayers((Collection)this.hiders);
    }
    
    public ArrayList<Player> getOnlyNoneHidden() {
        return Utils.getPlayers((Collection)this.nonhidden);
    }
    
    public ArrayList<Player> getOnlyHidden() {
        return Utils.getPlayers((Collection)this.hidden);
    }
    
    public ArrayList<Player> getSeekers() {
        return Utils.getPlayers((Collection)this.seekers);
    }
    
    public void join(final Player player) {
        this.players.add(player.getName());
        this.updateSignPlayers();
        player.teleport(this.lobbySpawn);
        final boolean b = this.players.size() == this.minPlayers && this.state == ArenaState.WAITING;
        final String string = this.plugin.customization.messages.get("arena_join_broadcast").replace("%player%", player.getName()).replace("%players%", String.valueOf(this.players.size())).replace("%maxPlayers%", String.valueOf(this.maxPlayers)) + "\n" + (b ? this.plugin.customization.messages.get("arena_about_to_start") : ((this.minPlayers - this.players.size() > 0) ? this.plugin.customization.messages.get("arena_needs_players").replace("%players%", String.valueOf(this.minPlayers - this.players.size())) : ""));
        final Iterator<Player> iterator = this.getPlayers(false).iterator();
        while (iterator.hasNext()) {
            iterator.next().sendMessage(string);
        }
        if (b) {
            this.startLobbyTimer();
        }
        if (this.scoreboard != null) {
            this.scoreboard.apply(player);
        }
        Bukkit.getPluginManager().callEvent((Event)new HASPlayerJoinEvent(player, this));
    }
    
    public void leave(final Player player) {
        if (this.spectators.contains(player.getName())) {
            this.spectators.remove(player.getName());
            return;
        }
        this.players.remove(player.getName());
        this.updateSignPlayers();
        player.setScoreboard(Bukkit.getScoreboardManager().getNewScoreboard());
        if (this.hiders.contains(player.getName())) {
            final int size = this.hiders.size();
            this.hiders.remove(player.getName());
            if (this.scoreboard != null) {
                this.scoreboard.update("%arena_hiders%", size - 1);
            }
            if (this.plugin.disguiseManager != null) {
                this.plugin.disguiseManager.undisguise(player);
            }
            if (this.hidden.contains(player.getName())) {
                this.hidden.remove(player.getName());
                this.removeHidden(player);
            }
            else {
                this.nonhidden.remove(player.getName());
            }
        }
        else if (this.seekers.contains(player.getName())) {
            if (this.scoreboard != null) {
                this.scoreboard.update("%arena_seekers%", this.seekers.size() - 1);
            }
            this.seekers.remove(player.getName());
            for (final Player player2 : this.getOnlyHidden()) {
                player.showPlayer(player2);
                this.plugin.sendBlockChange(player, player2.getLocation(), Material.AIR, 0);
            }
        }
        this.playerDisguise.remove(player.getName());
        if (this.state == ArenaState.WAITING || this.state == ArenaState.STARTING) {
            final String replace = this.plugin.customization.messages.get("arena_leave_broadcast").replace("%player%", player.getName()).replace("%players%", String.valueOf(this.players.size())).replace("%maxPlayers%", String.valueOf(this.maxPlayers));
            final Iterator<Player> iterator2 = this.getPlayers(false).iterator();
            while (iterator2.hasNext()) {
                iterator2.next().sendMessage(replace);
            }
            if (this.players.size() < this.minPlayers && this.state == ArenaState.STARTING) {
                this.state = ArenaState.WAITING;
                this.updateSignState();
                final String s = this.plugin.customization.messages.get("arena_cancel");
                for (final Player player3 : this.getPlayers(false)) {
                    player3.sendMessage(s);
                    player3.setLevel(0);
                }
                this.lobbyTimer.cancel();
                if (this.scoreboard != null) {
                    this.scoreboard.update("%state%", this.state.text);
                    this.scoreboard.update("%timer%", "0:00");
                }
            }
            return;
        }
        if (this.state.equals(ArenaState.INGAME)) {
            if (this.seekers.isEmpty()) {
                if (Config.getInstance().AntiSeekerQuit && this.hiders.size() > Config.getInstance().AntiSeekerQuitActivationHidersRequired) {
                    final ArrayList<Player> players = this.getPlayers(false);
                    final Player player4 = players.get(Utils.random.nextInt(players.size()));
                    this.plugin.clearPlayerData(player4);
                    this.moveHiderToSeeker(player4);
                    final String replace2 = this.plugin.customization.messages.get("anti_seeker_quit_activation").replace("%player%", player4.getName());
                    final Iterator<Player> iterator4 = this.getPlayers(true).iterator();
                    while (iterator4.hasNext()) {
                        iterator4.next().sendMessage(replace2);
                    }
                }
                else {
                    this.finishGame(true);
                }
            }
            else if (this.hiders.isEmpty()) {
                this.finishGame(false);
            }
            final PlayerData playerData2;
            final PlayerData playerData = playerData2 = this.plugin.playerData.get(player.getName());
            playerData2.seconds += (int)((System.currentTimeMillis() - this.currentGamePlayTime) / 1000L);
            this.plugin.updatePlayerPlayTime(playerData);
        }
        Bukkit.getPluginManager().callEvent((Event)new HASPlayerLeaveEvent(player, this));
    }
    
    public void startLobbyTimer() {
        this.state = ArenaState.STARTING;
        if (this.scoreboard != null) {
            this.scoreboard.update("%state%", this.state.text);
        }
        this.updateSignState();
        final Iterator<String> iterator = Config.getInstance().executedCmds_arenaCountdown.iterator();
        while (iterator.hasNext()) {
            Bukkit.dispatchCommand((CommandSender)Bukkit.getConsoleSender(), iterator.next().replace("%arena%", this.name).replace("%seconds%", String.valueOf(this.lobbyTime)));
        }
        this.lobbyTimer = new BukkitRunnable() {
            int timer = Arena.this.lobbyTime;
            
            public void run() {
                final Iterator<Player> iterator = Arena.this.getPlayers(false).iterator();
                while (iterator.hasNext()) {
                    iterator.next().setLevel(this.timer);
                }
                if (Arena.this.scoreboard != null) {
                    Arena.this.scoreboard.update("%timer%", Arena.getDurationString(this.timer));
                }
                if (Config.getInstance().ArenaStartWarnAt.contains(this.timer)) {
                    final String replace = Arena.this.plugin.customization.messages.get("arena_starting").replace("%seconds%", String.valueOf(this.timer));
                    for (final Player player : Arena.this.getPlayers(false)) {
                        player.sendMessage(replace);
                        Utils.playSound(player, "Arena-Starting");
                    }
                }
                if (this.timer == 0) {
                    this.cancel();
                    Arena.this.startGame();
                }
                --this.timer;
            }
        }.runTaskTimer((Plugin)this.plugin, 0L, 20L);
    }
    
    public void startGame() {
        this.state = ArenaState.INGAME;
        if (this.scoreboard != null) {
            this.scoreboard.update("%state%", this.state.text);
        }
        this.canUsefireWorks = false;
        this.updateSignState();
        final String s = this.plugin.customization.messages.get("arena_start");
        this.currentGamePlayTime = System.currentTimeMillis();
        final Iterator<String> iterator = Config.getInstance().executedCmds_arenaStart.iterator();
        while (iterator.hasNext()) {
            Bukkit.dispatchCommand((CommandSender)Bukkit.getConsoleSender(), iterator.next().replace("%world%", this.hidersSpawn.getWorld().getName()).replace("%arena%", this.name));
        }
        final ArrayList<Player> players = this.getPlayers(false);
        for (final Player player : players) {
            player.sendMessage(s);
            player.setLevel(0);
            player.getInventory().clear();
            Utils.playSound(player, "Arena-Start");
            while (this.plugin.grace.contains(player.getName())) {
                this.plugin.grace.remove(player.getName());
            }
            this.plugin.playerData.get(player.getName()).currentGameCoins = 0;
            this.plugin.playerData.get(player.getName()).currentGameExp = 0;
            this.plugin.playerData.get(player.getName()).currentGameFireworks = 0;
        }
        this.assignPlayersToTeams();
        if (!this.hidersSpawn.getChunk().isLoaded()) {
            this.hidersSpawn.getChunk().load(true);
        }
        for (final Player player2 : this.getHiders()) {
            player2.sendMessage(this.plugin.customization.messages.get("team_select").replace("%team%", ChatColor.GREEN + "Hider!"));
            player2.teleport(this.hidersSpawn);
            this.playersLocation.put(player2.getName(), player2.getLocation());
            final int n = this.plugin.playerData.get(player2.getName()).hasPerk(Perk.InstaSolid) ? 1 : this.hiders_become_solid_after;
            this.stillCounter.put(player2.getName(), n);
            player2.setLevel(n);
            final Iterator<PotionEffect> iterator4 = this.hiderEffects.iterator();
            while (iterator4.hasNext()) {
                player2.addPotionEffect((PotionEffect)iterator4.next());
            }
            player2.getInventory().setItem(1, this.plugin.firework);
            if (this.plugin.disguiseManager != null && !this.disguises.isEmpty()) {
                if (!this.playerDisguise.containsKey(player2.getName())) {
                    this.playerDisguise.put(player2.getName(), this.disguises.get(Utils.random.nextInt(this.disguises.size())));
                }
                final ItemStack helmet = this.playerDisguise.get(player2.getName());
                player2.sendMessage(this.plugin.customization.messages.get("player_disguise").replace("%disguise%", helmet.getType().name()));
                player2.getInventory().setItem(8, helmet);
                if (this.plugin.playerData.get(player2.getName()).hasPerk(Perk.DisguiseChanger)) {
                    player2.getInventory().setItem(2, Perk.DisguiseChanger.purchased);
                }
                if (helmet.getItemMeta().hasDisplayName() && helmet.getItemMeta().getDisplayName().contains("Mob: ")) {
                    this.plugin.disguiseManager.disguise(player2, helmet.getItemMeta().getDisplayName().replace("Mob: ", "").toUpperCase());
                    this.nonhidden.remove(player2.getName());
                }
                else {
                    player2.getInventory().setHelmet(helmet);
                    this.plugin.disguiseManager.disguise(player2, helmet);
                }
            }
            else {
                this.nonhidden.remove(player2.getName());
            }
        }
        for (final Player player3 : this.getSeekers()) {
            player3.sendMessage(this.plugin.customization.messages.get("team_select").replace("%team%", ChatColor.RED + "Seeker!"));
            this.respawnSeeker(player3, false);
            if (this.plugin.playerData.get(player3.getName()).hasPerk(Perk.SeekerSpeed)) {
                player3.addPotionEffect(new PotionEffect(PotionEffectType.SPEED, 9999999, 0));
            }
            final Iterator<PotionEffect> iterator6 = this.seekerEffects.iterator();
            while (iterator6.hasNext()) {
                player3.addPotionEffect((PotionEffect)iterator6.next());
            }
        }
        this.startGameTimer();
        if (this.scoreboard != null) {
            this.scoreboard.update("%arena_hiders%", this.hiders.size());
            this.scoreboard.update("%arena_seekers%", this.seekers.size());
        }
        Bukkit.getScheduler().scheduleSyncDelayedTask((Plugin)this.plugin, (Runnable)new Runnable() {
            @Override
            public void run() {
                Arena.this.canUsefireWorks = true;
                if (Config.getInstance().sendMessageOnSeekersRelease) {
                    for (final Player player : Arena.this.getPlayers(true)) {
                        player.sendMessage((String)Arena.this.plugin.customization.messages.get("seekers_release"));
                        Utils.playSound(player, "Seekers-Release");
                    }
                }
            }
        }, (long)Config.getInstance().SeekersInitialSpawnDelay);
        Bukkit.getPluginManager().callEvent((Event)new HASArenaStartEvent(this.name, (List)players));
    }
    
    public int getNextEvent(final int... array) {
        int n = 0;
        for (final int n2 : array) {
            if (n2 > n) {
                n = n2;
            }
        }
        return n;
    }
    
    public void startGameTimer() {
        this.gameTimer = new BukkitRunnable() {
            int Seconds = Arena.this.gameTime;
            final int warnEvery = Arena.this.warn_about_time_every;
            int nextWarn = this.Seconds - this.warnEvery;
            int nextCoinGive = this.Seconds - Config.getInstance().coinsTimerGiveEvery;
            int hidersItemsAt = this.Seconds - Arena.this.give_hider_items_after;
            int nextPowerups = this.Seconds - Arena.this.powerups_spawn_every;
            int nextPowerupsWarn = this.nextPowerups + 5;
            int nextEvent = Arena.this.getNextEvent(this.nextWarn, this.nextCoinGive, this.hidersItemsAt, this.nextPowerupsWarn);
            
            public void run() {
                if (Arena.this.scoreboard != null) {
                    Arena.this.scoreboard.update("%timer%", Arena.getDurationString(this.Seconds));
                }
                for (final Player player : Arena.this.getHiders()) {
                    if (Arena.this.nonhidden.contains(player.getName())) {
                        final Location location = Arena.this.playersLocation.get(player.getName());
                        final Location location2 = player.getLocation();
                        int intValue = Arena.this.stillCounter.get(player.getName());
                        if (location.getBlockX() == location2.getBlockX() && location.getBlockY() == location2.getBlockY() && location.getBlockZ() == location2.getBlockZ()) {
                            if (intValue == 0) {
                                if (Arena.this.plugin.disguisedBlocks.containsKey(player.getLocation().getBlock().getLocation())) {
                                    player.setVelocity(new Vector(Utils.random.nextInt(2), 1, Utils.random.nextInt(2)));
                                    Arena.this.playersLocation.put(player.getName(), player.getLocation());
                                    final int n = Arena.this.plugin.playerData.get(player.getName()).hasPerk(Perk.InstaSolid) ? 1 : Arena.this.hiders_become_solid_after;
                                    if (intValue == n) {
                                        continue;
                                    }
                                    Arena.this.stillCounter.put(player.getName(), n);
                                    player.setLevel(n);
                                }
                                else if (location2.getBlock().getType() == Material.AIR) {
                                    Arena.this.hidden.add(player.getName());
                                    Arena.this.nonhidden.remove(player.getName());
                                    final ItemStack itemStack = Arena.this.playerDisguise.get(player.getName());
                                    for (final Player player2 : Arena.this.getPlayers(true)) {
                                        if (player != player2) {
                                            player2.hidePlayer(player);
                                            Arena.this.plugin.sendBlockChange(player2, player.getLocation(), itemStack.getType(), itemStack.getDurability());
                                        }
                                    }
                                    Arena.this.plugin.disguisedBlocks.put(player.getLocation().getBlock().getLocation(), player.getName());
                                    player.sendMessage((String)Arena.this.plugin.customization.messages.get("disguise_complete"));
                                }
                                else {
                                    player.sendMessage((String)Arena.this.plugin.customization.messages.get("disguise_error"));
                                }
                            }
                            else {
                                --intValue;
                                Arena.this.stillCounter.put(player.getName(), intValue);
                                player.setLevel(intValue);
                            }
                        }
                        else {
                            Arena.this.playersLocation.put(player.getName(), player.getLocation());
                            final int n2 = Arena.this.plugin.playerData.get(player.getName()).hasPerk(Perk.InstaSolid) ? 1 : Arena.this.hiders_become_solid_after;
                            if (intValue == n2) {
                                continue;
                            }
                            Arena.this.stillCounter.put(player.getName(), n2);
                            player.setLevel(n2);
                        }
                    }
                    else {
                        if (!Arena.this.hidden.contains(player.getName())) {
                            continue;
                        }
                        final ItemStack itemStack2 = Arena.this.playerDisguise.get(player.getName());
                        final Location location3 = player.getLocation();
                        for (final Player player3 : Arena.this.getPlayers(true)) {
                            if (player3 != player) {
                                Arena.this.plugin.sendBlockChange(player3, location3, itemStack2.getType(), itemStack2.getDurability());
                            }
                        }
                    }
                }
                if (this.Seconds == this.nextEvent) {
                    if (this.Seconds == this.nextCoinGive) {
                        for (final Player player4 : Arena.this.getPlayers(false)) {
                            final PlayerData playerData = Arena.this.plugin.playerData.get(player4.getName());
                            final int i = Config.getInstance().coinsTimerAmount * playerData.modifier;
                            player4.sendMessage(Arena.this.plugin.customization.messages.get("player_earn_coins").replace("%earnedCoins%", String.valueOf(i)) + ((playerData.modifier != 1) ? (" (x" + playerData.modifier + ")") : ""));
                            final PlayerData playerData2 = playerData;
                            playerData2.currentGameCoins += i;
                            playerData.addCoins(player4, i);
                        }
                        this.nextCoinGive = this.Seconds - Config.getInstance().coinsTimerGiveEvery;
                    }
                    if (this.Seconds == this.nextWarn) {
                        if (this.Seconds > this.warnEvery) {
                            this.nextWarn -= this.warnEvery;
                        }
                        else if (this.nextWarn > 5) {
                            this.nextWarn = 5;
                        }
                        if (this.Seconds > 1 && this.Seconds < 6) {
                            --this.nextWarn;
                        }
                        for (final Player player5 : Arena.this.getPlayers(true)) {
                            player5.sendMessage(Arena.this.plugin.customization.messages.get("game_time_remaining").replace("%seconds%", String.valueOf(this.Seconds)));
                            Utils.playSound(player5, "Game-Time-Remaining");
                        }
                    }
                    if (this.Seconds == this.hidersItemsAt) {
                        for (final Player player6 : Arena.this.getHiders()) {
                            player6.getInventory().setBoots(Arena.this.plugin.hiderArmor[0]);
                            player6.getInventory().setLeggings(Arena.this.plugin.hiderArmor[1]);
                            player6.getInventory().setChestplate(Arena.this.plugin.hiderArmor[2]);
                            for (final ItemStack itemStack3 : Arena.this.plugin.hiderItems) {
                                if (itemStack3 == null) {
                                    break;
                                }
                                player6.getInventory().addItem(new ItemStack[] { itemStack3 });
                            }
                            Utils.playSound(player6, "Hider-Receive-Equipment");
                            player6.sendMessage((String)Arena.this.plugin.customization.messages.get("hiders_receive_items"));
                        }
                        this.hidersItemsAt = -1;
                    }
                    if (this.Seconds == this.nextPowerupsWarn && !Arena.this.powerups.isEmpty()) {
                        if (this.Seconds == this.nextPowerups) {
                            this.nextPowerups -= Arena.this.powerups_spawn_every;
                            final String s = Arena.this.plugin.customization.messages.get("powerups_spawn");
                            for (final Player player7 : Arena.this.getPlayers(true)) {
                                player7.sendMessage(s);
                                Utils.playSound(player7, "Powerups-Spawn");
                            }
                            final Iterator<Item> iterator8 = Arena.this.powerupsItems.iterator();
                            while (iterator8.hasNext()) {
                                iterator8.next().remove();
                            }
                            for (final Location location4 : Arena.this.powerups) {
                                final Item dropItem = location4.getWorld().dropItem(location4, (ItemStack)Arena.this.plugin.powerups.get(Utils.random.nextInt(Arena.this.plugin.powerups.size())));
                                dropItem.setVelocity(new Vector(0, 0, 0));
                                Arena.this.powerupsItems.add(dropItem);
                            }
                            this.nextPowerupsWarn = this.nextPowerups + 5;
                        }
                        else {
                            --this.nextPowerupsWarn;
                            final String replace = Arena.this.plugin.customization.messages.get("powerup_about_to_spawn").replace("%seconds%", String.valueOf(this.Seconds - this.nextPowerups));
                            final Iterator<Player> iterator10 = Arena.this.getPlayers(true).iterator();
                            while (iterator10.hasNext()) {
                                iterator10.next().sendMessage(replace);
                            }
                        }
                    }
                    this.nextEvent = Arena.this.getNextEvent(this.nextWarn, this.nextCoinGive, this.hidersItemsAt, this.nextPowerupsWarn);
                }
                if (this.Seconds == 0) {
                    Arena.this.finishGame(true);
                    this.cancel();
                }
                --this.Seconds;
            }
        }.runTaskTimer((Plugin)this.plugin, 0L, 20L);
    }
    
    public void finishGame(final boolean b) {
        this.gameTimer.cancel();
        this.canUsefireWorks = false;
        this.state = ArenaState.ENDING;
        if (this.scoreboard != null) {
            this.scoreboard.update("%state%", this.state.text);
        }
        this.updateSignState();
        final BungeeMode bungeeMode = this.plugin.bungeeMode;
        ++bungeeMode.Games;
        final String replace = this.plugin.customization.messages.get("team_win").replace("%team%", b ? (ChatColor.GREEN + "Hiders") : (ChatColor.RED + "Seekers"));
        for (final Player player : this.getPlayers(true)) {
            if (!this.spectators.contains(player.getName())) {
                this.updateMatchGainings(player);
                this.plugin.grace.add(player.getName());
            }
            player.sendMessage(replace);
            Utils.playSound(player, "Game-Finish");
            if (this.plugin.game_end_title != null) {
                TitleManager.getInstance().sendTitle(player, this.plugin.game_end_title);
            }
        }
        if (b) {
            final Iterator<Player> iterator2 = this.getHiders().iterator();
            while (iterator2.hasNext()) {
                this.rewardWinner(iterator2.next());
            }
            final Iterator<Player> iterator3 = this.getSeekers().iterator();
            while (iterator3.hasNext()) {
                this.rewardLoser(iterator3.next());
            }
        }
        else if (Config.getInstance().rewardStartingSeekers) {
            new BukkitRunnable() {
                public void run() {
                    for (final Player player : Arena.this.getSeekers()) {
                        if (Arena.this.startingSeekers.contains(player.getName())) {
                            Arena.this.rewardWinner(player);
                        }
                        else {
                            Arena.this.rewardLoser(player);
                        }
                    }
                }
            }.runTaskLater((Plugin)this.plugin, 1L);
        }
        new BukkitRunnable() {
            int Seconds = Config.getInstance().EndingLength;
            int nextFirework = this.Seconds;
            
            public void run() {
                if (Arena.this.scoreboard != null) {
                    Arena.this.scoreboard.update("%timer%", Arena.getDurationString(this.Seconds));
                }
                if (this.Seconds == this.nextFirework) {
                    for (final Player player : b ? Arena.this.getHiders() : Arena.this.getSeekers()) {
                        final Firework firework = (Firework)player.getWorld().spawn(player.getLocation(), (Class)Firework.class);
                        final FireworkMeta fireworkMeta = firework.getFireworkMeta();
                        fireworkMeta.addEffect(FireworkEffect.builder().flicker(Utils.random.nextBoolean()).withColor(Color.fromBGR(Utils.random.nextInt(256), Utils.random.nextInt(256), Utils.random.nextInt(256))).withFade(Color.fromBGR(Utils.random.nextInt(256), Utils.random.nextInt(256), Utils.random.nextInt(256))).with(FireworkEffect.Type.STAR).trail(true).build());
                        firework.setFireworkMeta(fireworkMeta);
                    }
                    this.nextFirework -= Config.getInstance().fireworksDelayInBetween;
                }
                if (this.Seconds == 0) {
                    if (Config.getInstance().bungeeEnabled) {
                        final ByteArrayDataOutput dataOutput = ByteStreams.newDataOutput();
                        dataOutput.writeUTF("Connect");
                        dataOutput.writeUTF(Arena.this.plugin.bungeeMode.hub);
                        final Iterator<Object> iterator2 = Arena.this.getSpectators().iterator();
                        while (iterator2.hasNext()) {
                            iterator2.next().sendPluginMessage((Plugin)Arena.this.plugin, "BungeeCord", dataOutput.toByteArray());
                        }
                    }
                    else {
                        final Iterator<Player> iterator3 = Arena.this.getSpectators().iterator();
                        while (iterator3.hasNext()) {
                            iterator3.next().performCommand("has leave");
                        }
                    }
                    final ArrayList<Player> players = Arena.this.getPlayers(false);
                    for (final Player player2 : players) {
                        if (!Config.getInstance().bungeeEnabled) {
                            Arena.this.plugin.game.remove(player2.getName());
                            Arena.this.plugin.grace.remove(player2.getName());
                            player2.getInventory().clear();
                            player2.getInventory().setArmorContents((ItemStack[])null);
                            Arena.this.plugin.playerData.get(player2.getName()).restoreData(player2);
                            player2.setScoreboard(Bukkit.getScoreboardManager().getNewScoreboard());
                        }
                        if (Arena.this.hiders.contains(player2.getName())) {
                            if (Arena.this.plugin.disguiseManager != null) {
                                Arena.this.plugin.disguiseManager.undisguise(player2);
                            }
                            if (Arena.this.hidden.contains(player2.getName())) {
                                Arena.this.removeHidden(player2);
                            }
                        }
                        player2.setFireTicks(0);
                        if (Config.getInstance().playAgainMessage && Arena.this.plugin.clickableTextManager != null) {
                            player2.sendMessage(Config.getInstance().playAgainHeader);
                            for (final String s : Config.getInstance().playAgainContent) {
                                if (s.equals(" ")) {
                                    player2.sendMessage(s);
                                }
                                else {
                                    Arena.this.plugin.clickableTextManager.sendMessage(player2, s, "hideandseek autojoin");
                                }
                            }
                            player2.sendMessage(Config.getInstance().playAgainFooter);
                        }
                    }
                    if (Arena.this.scoreboard != null) {
                        Arena.this.scoreboard.update("%arena_hiders%", 0);
                        Arena.this.scoreboard.update("%arena_seekers%", 0);
                        Arena.this.scoreboard.update("%state%", ArenaState.WAITING.text);
                        Arena.this.scoreboard.update("%timer%", "0:00");
                    }
                    Arena.this.clearLists();
                    Arena.this.state = ArenaState.WAITING;
                    Arena.this.updateSignState();
                    Arena.this.updateSignPlayers();
                    Bukkit.getPluginManager().callEvent((Event)new HASArenaStopEvent(Arena.this.name, (List)players));
                    if (Config.getInstance().bungeeEnabled) {
                        if (Arena.this.plugin.bungeeMode.Games == Config.getInstance().bungee_amount_of_games_till_restart) {
                            Arena.arenaObjects.clear();
                            final ByteArrayDataOutput dataOutput2 = ByteStreams.newDataOutput();
                            dataOutput2.writeUTF("Connect");
                            dataOutput2.writeUTF(Arena.this.plugin.bungeeMode.hub);
                            final Iterator iterator6 = Utils.getOnlinePlayers().iterator();
                            while (iterator6.hasNext()) {
                                ((Player)iterator6.next()).sendPluginMessage((Plugin)Arena.this.plugin, "BungeeCord", dataOutput2.toByteArray());
                            }
                            Bukkit.getScheduler().scheduleSyncDelayedTask((Plugin)Arena.this.plugin, (Runnable)new Runnable() {
                                @Override
                                public void run() {
                                    final Iterator<String> iterator = Config.getInstance().bungee_executed_commands_to_restart.iterator();
                                    while (iterator.hasNext()) {
                                        Bukkit.dispatchCommand((CommandSender)Bukkit.getConsoleSender(), (String)iterator.next());
                                    }
                                }
                            }, 40L);
                        }
                        else {
                            Arena.this.plugin.game.clear();
                            Arena.this.plugin.grace.clear();
                            Arena.this.plugin.bungeeMode.selectedArena = null;
                            Arena.this.plugin.bungeeMode.createScoreboard();
                            final Iterator iterator7 = Utils.getOnlinePlayers().iterator();
                            while (iterator7.hasNext()) {
                                Arena.this.plugin.bungeeMode.join((Player)iterator7.next(), true);
                            }
                            Arena.this.plugin.bungeeMode.scoreboard.update("%players%", Utils.getOnlinePlayers().size());
                        }
                    }
                    this.cancel();
                }
                --this.Seconds;
            }
        }.runTaskTimer((Plugin)this.plugin, 0L, 20L);
        final Date date = new Date();
        if (!this.plugin.dateFormat.format(date).equalsIgnoreCase(this.date)) {
            this.date = this.plugin.dateFormat.format(date);
            if (this.scoreboard != null) {
                this.scoreboard.update("%date%", this.date);
            }
        }
        final Iterator<Item> iterator4 = this.powerupsItems.iterator();
        while (iterator4.hasNext()) {
            iterator4.next().remove();
        }
    }
    
    private void rewardWinner(final Player player) {
        final PlayerData playerData2;
        final PlayerData playerData = playerData2 = this.plugin.playerData.get(player.getName());
        ++playerData2.wins;
        AchievementsManager.getInstance().checkPlayer(player, AchievementsManager.AchievementType.WINS, playerData.wins);
        if (this.plugin.customMapsManager.isRegistered("winnerMap")) {
            player.setItemInHand(this.plugin.customMapsManager.getItemStack("winnerMap"));
        }
        final Iterator<String> iterator = Config.getInstance().commandsExecutedOnWinners.iterator();
        while (iterator.hasNext()) {
            Bukkit.dispatchCommand((CommandSender)this.plugin.console, iterator.next().replace("%player%", player.getName()));
        }
    }
    
    private void rewardLoser(final Player player) {
        if (this.plugin.customMapsManager.isRegistered("loserMap")) {
            player.getInventory().setItemInHand(this.plugin.customMapsManager.getItemStack("loserMap"));
        }
        final Iterator<String> iterator = Config.getInstance().commandsExecutedOnLosers.iterator();
        while (iterator.hasNext()) {
            Bukkit.dispatchCommand((CommandSender)this.plugin.console, iterator.next().replace("%player%", player.getName()));
        }
    }
    
    public void kickAll() {
        this.state = ArenaState.WAITING;
        if (this.gameTimer != null) {
            this.gameTimer.cancel();
        }
        if (this.lobbyTimer != null) {
            this.lobbyTimer.cancel();
        }
        final Iterator<Player> iterator = this.getSpectators().iterator();
        while (iterator.hasNext()) {
            iterator.next().performCommand("has leave");
        }
        final ArrayList<Player> players = this.getPlayers(false);
        for (final Player player : players) {
            this.plugin.game.remove(player.getName());
            this.plugin.grace.remove(player.getName());
            this.plugin.playerData.get(player.getName()).restoreData(player);
            player.setFireTicks(0);
            player.sendMessage((String)this.plugin.customization.messages.get("arena_leave"));
            player.setScoreboard(Bukkit.getScoreboardManager().getNewScoreboard());
            if (this.hiders.contains(player.getName())) {
                if (this.plugin.disguiseManager != null) {
                    this.plugin.disguiseManager.undisguise(player);
                }
                if (!this.hidden.contains(player.getName())) {
                    continue;
                }
                this.removeHidden(player);
            }
        }
        if (this.scoreboard != null) {
            this.scoreboard.update("%arena_hiders%", 0);
            this.scoreboard.update("%arena_seekers%", 0);
        }
        this.clearLists();
        this.updateSignPlayers();
        this.updateSignState();
        final Iterator<Item> iterator3 = this.powerupsItems.iterator();
        while (iterator3.hasNext()) {
            iterator3.next().remove();
        }
        Bukkit.getPluginManager().callEvent((Event)new HASArenaStopEvent(this.name, (List)players));
    }
    
    private void clearLists() {
        this.players.clear();
        this.spectators.clear();
        this.seekers.clear();
        this.startingSeekers.clear();
        this.hiders.clear();
        this.nonhidden.clear();
        this.hidden.clear();
        this.playersLocation.clear();
        this.stillCounter.clear();
        this.playerDisguise.clear();
    }
    
    public void assignPlayersToTeams() {
        final HashMap hashMap = new HashMap();
        for (final String s : this.players) {
            hashMap.put(s, Utils.random.nextInt(this.plugin.playerData.get(s).hiderChance));
        }
        final ArrayList c = new ArrayList<String>(hashMap.keySet());
        Collections.sort((List<E>)c, (Comparator<? super E>)new Comparator<String>() {
            @Override
            public int compare(final String key, final String key2) {
                return hashMap.get(key) - hashMap.get(key2);
            }
        });
        while (this.seekers.size() < this.startingAmountOfSeekers) {
            final String o = c.get(0);
            this.seekers.add(o);
            this.startingSeekers.add(o);
            c.remove(o);
        }
        this.hiders.addAll((Collection<? extends String>)c);
        this.nonhidden.addAll((Collection<? extends String>)c);
    }
    
    public void respawnSeeker(final Player player, final boolean b) {
        player.teleport(this.seekersWaitingSpawn);
        Bukkit.getScheduler().scheduleSyncDelayedTask((Plugin)this.plugin, (Runnable)new Runnable() {
            @Override
            public void run() {
                if (Arena.this.seekers.contains(player.getName())) {
                    player.teleport(Arena.this.seekersPlayingSpawn);
                    player.getInventory().setContents(Arena.this.plugin.seekerItems);
                    player.getInventory().setArmorContents(Arena.this.plugin.seekerArmor);
                    final PlayerData playerData = Arena.this.plugin.playerData.get(player.getName());
                    if (Arena.this.plugin.disguiseManager != null && playerData.hasPerk(Perk.DisguisesDetector)) {
                        player.getInventory().addItem(new ItemStack[] { Perk.DisguisesDetector.purchased });
                    }
                    if (playerData.hasPerk(Perk.ThrowableTNT)) {
                        player.getInventory().addItem(new ItemStack[] { Perk.ThrowableTNT.purchased });
                    }
                }
            }
        }, b ? ((long)Config.getInstance().SeekersRespawnDelay) : ((long)Config.getInstance().SeekersInitialSpawnDelay));
    }
    
    public void updateMatchGainings(final Player player) {
        final PlayerData playerData = this.plugin.playerData.get(player.getName());
        final Iterator<String> iterator = this.plugin.customization.matchEarnings.iterator();
        while (iterator.hasNext()) {
            player.sendMessage(iterator.next().replace("%game_coins%", String.valueOf(playerData.currentGameCoins)).replace("%game_exp%", String.valueOf(playerData.currentGameExp)).replace("%game_fireworks%", String.valueOf(playerData.currentGameFireworks)).replace("%game_playtime%", (System.currentTimeMillis() - this.currentGamePlayTime) / 1000L + "s"));
        }
        final PlayerData playerData2 = playerData;
        playerData2.seconds += (int)((System.currentTimeMillis() - this.currentGamePlayTime) / 1000L);
        playerData.currentGameCoins = 0;
        playerData.currentGameExp = 0;
        playerData.currentGameFireworks = 0;
        final PlayerData playerData3 = playerData;
        ++playerData3.gamesPlayed;
        AchievementsManager.getInstance().checkPlayer(player, AchievementsManager.AchievementType.GAMES_PLAYED, playerData.gamesPlayed);
        this.plugin.updatePlayerPlayTime(playerData);
    }
    
    public void removeHidden(final Player player) {
        Location key = null;
        for (final Location key2 : this.plugin.disguisedBlocks.keySet()) {
            if (this.plugin.disguisedBlocks.get(key2).equalsIgnoreCase(player.getName())) {
                key = key2;
            }
        }
        for (final Player player2 : this.getPlayers(true)) {
            player2.showPlayer(player);
            this.plugin.sendBlockChange(player2, key, Material.AIR, 0);
        }
        this.plugin.disguisedBlocks.remove(key);
    }
    
    public void moveHiderToSeeker(final Player player) {
        if (this.plugin.disguiseManager != null) {
            this.plugin.disguiseManager.undisguise(player);
        }
        this.hiders.remove(player.getName());
        this.seekers.add(player.getName());
        if (this.hidden.contains(player.getName())) {
            this.removeHidden(player);
            this.hidden.remove(player.getName());
        }
        else {
            this.nonhidden.remove(player.getName());
        }
        this.respawnSeeker(player, true);
        player.setLevel(0);
        if (this.scoreboard != null) {
            this.scoreboard.update("%arena_hiders%", this.hiders.size());
            this.scoreboard.update("%arena_seekers%", this.seekers.size());
        }
    }
    
    public void updateSignState() {
        this.updateArenaItem();
        if (this.sign == null) {
            return;
        }
        final Block block = this.sign.getWorld().getBlockAt(this.sign);
        if (block.getState() instanceof Sign) {
            final Sign sign = (Sign)block.getState();
            sign.setLine(2, this.state.text);
            sign.update();
            this.updateStateBlock();
        }
    }
    
    public void updateSignPlayers() {
        this.updateArenaItem();
        if (this.sign == null) {
            return;
        }
        final Block block = this.sign.getWorld().getBlockAt(this.sign);
        if (block.getState() instanceof Sign) {
            final Sign sign = (Sign)block.getState();
            sign.setLine(3, this.plugin.customization.sign_join_line4_format.replace("%players%", String.valueOf(this.players.size())).replace("%maxplayers%", String.valueOf(this.maxPlayers)));
            sign.update();
        }
    }
    
    public void updateArenaItem() {
        if (this.plugin.joinGui == null) {
            return;
        }
        new ItemStackBuilder(this.arenaItem).clearLore().addLore(new String[] { this.state.text + " - " + this.plugin.customization.sign_join_line4_format.replace("%players%", String.valueOf(this.players.size())).replace("%maxplayers%", String.valueOf(this.maxPlayers)) }).build();
        if (this.arenaNumber < this.plugin.joinGui.getSize()) {
            this.plugin.joinGui.setItem(this.arenaNumber, this.arenaItem);
        }
    }
    
    public void updateStateBlock() {
        if (this.behindSign == null) {
            return;
        }
        byte b = 14;
        if (this.state.equals(ArenaState.WAITING)) {
            b = 5;
        }
        else if (this.state.equals(ArenaState.STARTING)) {
            b = 4;
        }
        if (XMaterial.supports(13)) {
            this.behindSign.getBlock().setType(((XMaterial)XMaterial.matchXMaterial("STAINED_GLASS:" + b).get()).parseMaterial());
        }
        else {
            try {
                ReflectionUtils.setTypeAndDataMethod.invoke(this.behindSign.getBlock(), 95, b, false);
            }
            catch (final IllegalAccessException | InvocationTargetException ex) {
                ((Throwable)ex).printStackTrace();
            }
        }
    }
    
    public void updateBehindSign() {
        if (this.sign == null || !(this.sign.getBlock().getState() instanceof Sign) || !Config.getInstance().UpdateBlockBehindSign) {
            this.behindSign = null;
            return;
        }
        if (XMaterial.supports(13)) {
            try {
                final Object invoke = Block.class.getMethod("getBlockData", (Class<?>[])new Class[0]).invoke(this.sign.getBlock(), new Object[0]);
                this.behindSign = this.sign.getBlock().getRelative(((BlockFace)invoke.getClass().getMethod("getFacing", (Class<?>[])new Class[0]).invoke(invoke, new Object[0])).getOppositeFace()).getLocation();
            }
            catch (final IllegalAccessException | IllegalArgumentException | InvocationTargetException | NoSuchMethodException | SecurityException ex) {
                ((Throwable)ex).printStackTrace();
            }
        }
        else {
            final BlockFace facing = ((org.bukkit.material.Sign)this.sign.getBlock().getState().getData()).getFacing();
            this.behindSign = this.sign.clone();
            if (facing.equals((Object)BlockFace.WEST)) {
                this.behindSign.add(1.0, 0.0, 0.0);
            }
            else if (facing.equals((Object)BlockFace.SOUTH)) {
                this.behindSign.add(0.0, 0.0, -1.0);
            }
            else if (facing.equals((Object)BlockFace.EAST)) {
                this.behindSign.add(-1.0, 0.0, 0.0);
            }
            else if (facing.equals((Object)BlockFace.NORTH)) {
                this.behindSign.add(0.0, 0.0, 1.0);
            }
        }
    }
    
    static {
        Arena.arenaObjects = new ArrayList<Arena>();
    }
    
    public enum ArenaState
    {
        WAITING(true), 
        STARTING(true), 
        INGAME(false), 
        ENDING(false), 
        DISABLED(false);
        
        public String text;
        public boolean available;
        
        private ArenaState(final boolean available) {
            this.available = available;
        }
    }
}
